/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the GoogleCloudStorageDestinationAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &GoogleCloudStorageDestinationAllOf{}

// GoogleCloudStorageDestinationAllOf struct for GoogleCloudStorageDestinationAllOf
type GoogleCloudStorageDestinationAllOf struct {
	OAuthId *int32  `json:"o_auth_id,omitempty"`
	Bucket  *string `json:"bucket,omitempty"`
}

// NewGoogleCloudStorageDestinationAllOf instantiates a new GoogleCloudStorageDestinationAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewGoogleCloudStorageDestinationAllOf() *GoogleCloudStorageDestinationAllOf {
	this := GoogleCloudStorageDestinationAllOf{}
	return &this
}

// NewGoogleCloudStorageDestinationAllOfWithDefaults instantiates a new GoogleCloudStorageDestinationAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewGoogleCloudStorageDestinationAllOfWithDefaults() *GoogleCloudStorageDestinationAllOf {
	this := GoogleCloudStorageDestinationAllOf{}
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *GoogleCloudStorageDestinationAllOf) GetOAuthId() int32 {
	if o == nil || IsNil(o.OAuthId) {
		var ret int32
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleCloudStorageDestinationAllOf) GetOAuthIdOk() (*int32, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *GoogleCloudStorageDestinationAllOf) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given int32 and assigns it to the OAuthId field.
func (o *GoogleCloudStorageDestinationAllOf) SetOAuthId(v int32) {
	o.OAuthId = &v
}

// GetBucket returns the Bucket field value if set, zero value otherwise.
func (o *GoogleCloudStorageDestinationAllOf) GetBucket() string {
	if o == nil || IsNil(o.Bucket) {
		var ret string
		return ret
	}
	return *o.Bucket
}

// GetBucketOk returns a tuple with the Bucket field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *GoogleCloudStorageDestinationAllOf) GetBucketOk() (*string, bool) {
	if o == nil || IsNil(o.Bucket) {
		return nil, false
	}
	return o.Bucket, true
}

// HasBucket returns a boolean if a field has been set.
func (o *GoogleCloudStorageDestinationAllOf) HasBucket() bool {
	if o != nil && !IsNil(o.Bucket) {
		return true
	}

	return false
}

// SetBucket gets a reference to the given string and assigns it to the Bucket field.
func (o *GoogleCloudStorageDestinationAllOf) SetBucket(v string) {
	o.Bucket = &v
}

func (o GoogleCloudStorageDestinationAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o GoogleCloudStorageDestinationAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["o_auth_id"] = o.OAuthId
	}
	if !IsNil(o.Bucket) {
		toSerialize["bucket"] = o.Bucket
	}
	return toSerialize, nil
}

type NullableGoogleCloudStorageDestinationAllOf struct {
	value *GoogleCloudStorageDestinationAllOf
	isSet bool
}

func (v NullableGoogleCloudStorageDestinationAllOf) Get() *GoogleCloudStorageDestinationAllOf {
	return v.value
}

func (v *NullableGoogleCloudStorageDestinationAllOf) Set(val *GoogleCloudStorageDestinationAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullableGoogleCloudStorageDestinationAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullableGoogleCloudStorageDestinationAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableGoogleCloudStorageDestinationAllOf(val *GoogleCloudStorageDestinationAllOf) *NullableGoogleCloudStorageDestinationAllOf {
	return &NullableGoogleCloudStorageDestinationAllOf{value: val, isSet: true}
}

func (v NullableGoogleCloudStorageDestinationAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableGoogleCloudStorageDestinationAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
